import React, { useMemo } from 'react';
import { useSandpack, FileTabs, useSandpackNavigation } from '@codesandbox/sandpack-react';
import IconReset from './IconReset';
import IconGitHub from './IconGithub';
export default function NavigationBar(_ref) {
  var showDevTools = _ref.showDevTools,
      changeShowDevTools = _ref.changeShowDevTools;

  var _useSandpack = useSandpack(),
      sandpack = _useSandpack.sandpack;

  var clients = sandpack.clients,
      activeFile = sandpack.activeFile,
      files = sandpack.files;

  var _useSandpackNavigatio = useSandpackNavigation(Object.keys(clients)[0]),
      refresh = _useSandpackNavigatio.refresh;

  var handleReset = function handleReset() {
    sandpack.resetAllFiles();
    refresh();
  };

  var openGithubEditUrl = useMemo(function () {
    var _files$activeFile;

    // @ts-ignore
    var editUrl = (_files$activeFile = files[activeFile]) == null ? void 0 : _files$activeFile.editUrl;
    return editUrl;
  }, [activeFile, files]);
  return /*#__PURE__*/React.createElement("div", {
    className: "taro-hooks--sandpack__navigation flex items-center justify-between"
  }, /*#__PURE__*/React.createElement("div", {
    className: "taro-hooks--sandpack__navigation__tabs sp-declaration"
  }, /*#__PURE__*/React.createElement(FileTabs, null)), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("button", {
    className: "button button--sm button--outline button--primary",
    onClick: function onClick() {
      return changeShowDevTools(!showDevTools);
    }
  }, showDevTools ? '关闭调试' : '打开调试'), openGithubEditUrl && /*#__PURE__*/React.createElement("a", {
    className: "button button--sm button--outline button--link",
    href: openGithubEditUrl,
    target: "__blank"
  }, /*#__PURE__*/React.createElement(IconGitHub, null), " Github"), /*#__PURE__*/React.createElement("button", {
    onClick: handleReset,
    type: "button",
    className: "button button--sm button--outline button--link"
  }, /*#__PURE__*/React.createElement(IconReset, null), " \u91CD\u7F6E")));
}