import React, { useState, useRef, useMemo, useEffect } from 'react';
import { LoadingOverlay, useSandpack } from '@codesandbox/sandpack-react';
export default function Preview(_ref) {
  var isExpanded = _ref.isExpanded;

  var _useSandpack = useSandpack(),
      sandpack = _useSandpack.sandpack,
      listen = _useSandpack.listen;

  var _useState = useState(false),
      isReady = _useState[0],
      setIsReady = _useState[1];

  var _useState2 = useState(null),
      iframeComputedHeight = _useState2[0],
      setComputedHeight = _useState2[1];

  var registerBundler = sandpack.registerBundler,
      unregisterBundler = sandpack.unregisterBundler,
      loadingScreenRegisteredRef = sandpack.loadingScreenRegisteredRef,
      status = sandpack.status;
  var clientId = useRef(Math.floor(Math.random() * 100000).toString());
  var iframeRef = useRef(null);
  loadingScreenRegisteredRef.current = true;
  var iframeWrapperPosition = useMemo(function () {
    var hiddenContent = !isReady;
    return hiddenContent ? 'relative' : isExpanded ? 'sticky' : undefined;
  }, [isReady, isExpanded]);
  useEffect(function () {
    var iframeElement = iframeRef.current;
    registerBundler(iframeElement, clientId.current);
    return function () {
      unregisterBundler(clientId.current);
    };
  }, []);
  useEffect(function () {
    var unsubscribe = listen(function (message) {
      if (message.type === 'resize') {
        setComputedHeight(message.height);
      } else if (message.type === 'start') {
        if (message.firstLoad) {
          setIsReady(false);
        }
      } else if (message.type === 'done') {
        setIsReady(true);
      }
    }, clientId.current);
    return function () {
      setIsReady(false);
      setComputedHeight(null);
      unsubscribe();
    };
  }, [status === 'idle']);
  return /*#__PURE__*/React.createElement("div", {
    className: "sp-stack",
    style: {
      overflow: isReady ? 'auto' : 'hidden'
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "taro-hooks--sandpack__iframe",
    style: {
      padding: 'initial',
      position: iframeWrapperPosition
    }
  }, /*#__PURE__*/React.createElement("iframe", {
    ref: iframeRef,
    title: "taro-hooks sandpack preview",
    style: {
      height: iframeComputedHeight || '100%',
      zIndex: isExpanded ? 'initial' : -1
    }
  })), /*#__PURE__*/React.createElement(LoadingOverlay, {
    showOpenInCodeSandbox: false,
    clientId: clientId.current,
    loading: !isReady && iframeComputedHeight === null
  }));
}