import React from 'react';
export declare type SandpackRootProps = {
    /**
     * @description default docusaurus mdx childrens
     */
    children: React.ReactNode;
    /**
     * @description custom sandpack code
     */
    code?: string;
    /**
     * @description custom sandpack filePath
     */
    filePath?: string;
    /**
     * @description custom sandpack framework
     */
    frameWork?: 'vue3' | 'react';
    /**
     * @description custom sandpack deps as JSON
     */
    dependencies?: string;
    /**
     * @description custom editUrl
     */
    editUrl?: string;
    /**
     * @description custom sandpack theme
     */
    theme?: 'dark' | 'light';
    /**
     * @description custom sandpack externalResources
     */
    externalResources?: string[];
};
declare function SandpackRoot(props: SandpackRootProps): JSX.Element;
declare namespace SandpackRoot {
    var displayName: string;
}
export default SandpackRoot;
