/**
 * @description generate deps | devDeps by framework
 */
import type { SandpackPredefinedTemplate } from '@codesandbox/sandpack-react';
/**
 * @description generate deps by framework
 * @param {SandpackPredefinedTemplate} framework
 * @param {string} deps
 * @returns {Record<string, string>} deps
 */
export declare function getDeps(framework: SandpackPredefinedTemplate, deps?: string): Record<string, string>;
/**
 * @description generate devDeps by framework
 * @param {SandpackPredefinedTemplate} framework
 * @returns {Record<string, string>} devDeps
 */
export declare function getDevDeps(framework: SandpackPredefinedTemplate): Record<string, string>;
/**
 * generate props.deps
 * @param {JSON string} deps
 * @returns {Record<string, string>} deps
 */
export declare function generatePropsDeps(deps?: string): Record<string, string>;
export declare function addOnFiles(files: Record<string, any>, template: SandpackPredefinedTemplate): Record<string, any>;
