"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var tslib_1 = require("tslib");

var react_1 = tslib_1.__importStar(require("react"));

var sandpack_react_1 = require("@codesandbox/sandpack-react");

var IconReset_1 = tslib_1.__importDefault(require("./IconReset"));

var IconGithub_1 = tslib_1.__importDefault(require("./IconGithub"));

function NavigationBar(_ref) {
  var showDevTools = _ref.showDevTools,
      changeShowDevTools = _ref.changeShowDevTools;

  var _ref2 = (0, sandpack_react_1.useSandpack)(),
      sandpack = _ref2.sandpack;

  var clients = sandpack.clients,
      activeFile = sandpack.activeFile,
      files = sandpack.files;

  var _ref3 = (0, sandpack_react_1.useSandpackNavigation)(Object.keys(clients)[0]),
      refresh = _ref3.refresh;

  var handleReset = function handleReset() {
    sandpack.resetAllFiles();
    refresh();
  };

  var openGithubEditUrl = (0, react_1.useMemo)(function () {
    var _files$activeFile;

    // @ts-ignore
    var editUrl = (_files$activeFile = files[activeFile]) == null ? void 0 : _files$activeFile.editUrl;
    return editUrl;
  }, [activeFile, files]);
  return react_1["default"].createElement("div", {
    className: "taro-hooks--sandpack__navigation flex items-center justify-between"
  }, react_1["default"].createElement("div", {
    className: "taro-hooks--sandpack__navigation__tabs sp-declaration"
  }, react_1["default"].createElement(sandpack_react_1.FileTabs, null)), react_1["default"].createElement("div", null, react_1["default"].createElement("button", {
    className: "button button--sm button--outline button--primary",
    onClick: function onClick() {
      return changeShowDevTools(!showDevTools);
    }
  }, showDevTools ? '关闭调试' : '打开调试'), openGithubEditUrl && react_1["default"].createElement("a", {
    className: "button button--sm button--outline button--link",
    href: openGithubEditUrl,
    target: "__blank"
  }, react_1["default"].createElement(IconGithub_1["default"], null), " Github"), react_1["default"].createElement("button", {
    onClick: handleReset,
    type: "button",
    className: "button button--sm button--outline button--link"
  }, react_1["default"].createElement(IconReset_1["default"], null), " \u91CD\u7F6E")));
}

exports["default"] = NavigationBar;