"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var tslib_1 = require("tslib");

var react_1 = tslib_1.__importStar(require("react"));

var sandpack_react_1 = require("@codesandbox/sandpack-react");

function Preview(_ref) {
  var isExpanded = _ref.isExpanded;

  var _ref2 = (0, sandpack_react_1.useSandpack)(),
      sandpack = _ref2.sandpack,
      listen = _ref2.listen;

  var _ref3 = (0, react_1.useState)(false),
      isReady = _ref3[0],
      setIsReady = _ref3[1];

  var _ref4 = (0, react_1.useState)(null),
      iframeComputedHeight = _ref4[0],
      setComputedHeight = _ref4[1];

  var registerBundler = sandpack.registerBundler,
      unregisterBundler = sandpack.unregisterBundler,
      loadingScreenRegisteredRef = sandpack.loadingScreenRegisteredRef,
      status = sandpack.status;
  var clientId = (0, react_1.useRef)(Math.floor(Math.random() * 100000).toString());
  var iframeRef = (0, react_1.useRef)(null);
  loadingScreenRegisteredRef.current = true;
  var iframeWrapperPosition = (0, react_1.useMemo)(function () {
    var hiddenContent = !isReady;
    return hiddenContent ? 'relative' : isExpanded ? 'sticky' : undefined;
  }, [isReady, isExpanded]);
  (0, react_1.useEffect)(function () {
    var iframeElement = iframeRef.current;
    registerBundler(iframeElement, clientId.current);
    return function () {
      unregisterBundler(clientId.current);
    };
  }, []);
  (0, react_1.useEffect)(function () {
    var unsubscribe = listen(function (message) {
      if (message.type === 'resize') {
        setComputedHeight(message.height);
      } else if (message.type === 'start') {
        if (message.firstLoad) {
          setIsReady(false);
        }
      } else if (message.type === 'done') {
        setIsReady(true);
      }
    }, clientId.current);
    return function () {
      setIsReady(false);
      setComputedHeight(null);
      unsubscribe();
    };
  }, [status === 'idle']);
  return react_1["default"].createElement("div", {
    className: "sp-stack",
    style: {
      overflow: isReady ? 'auto' : 'hidden'
    }
  }, react_1["default"].createElement("div", {
    className: "taro-hooks--sandpack__iframe",
    style: {
      padding: 'initial',
      position: iframeWrapperPosition
    }
  }, react_1["default"].createElement("iframe", {
    ref: iframeRef,
    title: "taro-hooks sandpack preview",
    style: {
      height: iframeComputedHeight || '100%',
      zIndex: isExpanded ? 'initial' : -1
    }
  })), react_1["default"].createElement(sandpack_react_1.LoadingOverlay, {
    showOpenInCodeSandbox: false,
    clientId: clientId.current,
    loading: !isReady && iframeComputedHeight === null
  }));
}

exports["default"] = Preview;